xml_memory_page Struct Reference
Collaboration diagram for xml_memory_page:
[legend]

## Static Public Member Functions

static xml_memory_page * | construct (void *memory)

## Public Attributes

xml_allocator * | allocator
void * | memory
xml_memory_page * | prev
xml_memory_page * | next
size_t | busy_size
size_t | freed_size
char | data [1]

## Detailed Description

Definition at line 277 of file pugixml.cpp.

## Member Function Documentation

## construct()

static xml_memory_page* xml_memory_page::construct | ( | void * | memory | ) |

inline static

Definition at line 279 of file pugixml.cpp.

{
if (!memory) return 0; //$ redundant, left for performance
xml_memory_page* result = static_cast<xml_memory_page*>(memory);
result->allocator = 0;
result->memory = 0;
result->prev = 0;
result->next = 0;
result->busy_size = 0;
result->freed_size = 0;
return result;
}

References allocator, busy_size, freed_size, memory, next, and prev.

Referenced by xml_allocator::allocate_page().

## Member Data Documentation

## allocator

xml_allocator* xml_memory_page::allocator

Definition at line 295 of file pugixml.cpp.

Referenced by xml_allocator::allocate_page(), and construct().

## busy_size

size_t xml_memory_page::busy_size

Definition at line 302 of file pugixml.cpp.

Referenced by xml_allocator::allocate_memory_oob(), xml_allocator::allocate_string(), construct(), xml_allocator::deallocate_memory(), and xml_allocator::deallocate_string().

## data

char xml_memory_page::data[1]

Definition at line 305 of file pugixml.cpp.

Referenced by xml_allocator::allocate_memory(), xml_allocator::allocate_memory_oob(), xml_allocator::allocate_string(), and xml_allocator::deallocate_memory().

## freed_size

size_t xml_memory_page::freed_size

Definition at line 303 of file pugixml.cpp.

Referenced by construct(), and xml_allocator::deallocate_memory().

## memory

void* xml_memory_page::memory

Definition at line 297 of file pugixml.cpp.

Referenced by xml_allocator::allocate_page(), construct(), and xml_allocator::deallocate_page().

## next

xml_memory_page* xml_memory_page::next

Definition at line 300 of file pugixml.cpp.

Referenced by xml_allocator::allocate_memory_oob(), construct(), and xml_allocator::deallocate_memory().

## prev

xml_memory_page* xml_memory_page::prev

Definition at line 299 of file pugixml.cpp.

Referenced by xml_allocator::allocate_memory_oob(), construct(), and xml_allocator::deallocate_memory().

The documentation for this struct was generated from the following file:

- pugixml.cpp

xml_memory_page::busy_size
size_t busy_size
Definition: pugixml.cpp:302
xml_memory_page::next
xml_memory_page * next
Definition: pugixml.cpp:300
xml_memory_page::memory
void * memory
Definition: pugixml.cpp:297
xml_memory_page
Definition: pugixml.cpp:277
xml_memory_page::allocator
xml_allocator * allocator
Definition: pugixml.cpp:295
xml_memory_page::prev
xml_memory_page * prev
Definition: pugixml.cpp:299
xml_memory_page::freed_size
size_t freed_size
Definition: pugixml.cpp:303